<!DOCTYPE html>
<html>
<title> Task 44.30 Develop branch and merge Pizza 365 project</title>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1">

<!-- font -->
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">

<!-- Bootstrap -->
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
<script src="http://css-tricks.com/examples/TextareaTricks/js/autoresize.jquery.min.js"></script>
<style>
  #modal-order-detail input{
    width: 100%
  }
  #modal-order-detail textarea{
    width: 100%;
    height:auto
  }
</style>
<body>
    <div class="container-fluid bg-light">
        <div class="row">
            <div class="col-12">
                <nav class="navbar navbar-expand-lg navbar-light bg-light">
                    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                      <span class="navbar-toggler-icon"></span>
                    </button>
                    <div class="collapse navbar-collapse bg-warning" id="navbarNav">
                      <ul class="navbar-nav nav-fill w-100">
                        <li class="nav-item active">
                          <a class="nav-link" href="#">Trang chủ </a>
                        </li>
                        <li class="nav-item">
                          <a class="nav-link" href="#">Combo</a>
                        </li>
                        <li class="nav-item">
                          <a class="nav-link" href="#">Loại pizza</a>
                        </li>
                        <li class="nav-item">
                          <a class="nav-link " href="#">Gửi đơn hàng</a>
                        </li>
                      </ul>
                    </div>
                  </nav>
            </div>
        </div>
    </div>
    <!--Logo-->
    <div class="container" style="padding: 120px 0 50px 0;">
        <div class="text-warning">
            <h2><b>Pizza 365</b></h2>
            <h4><em>Truly italian!</em></h4>
        </div>
        <div id="carouselExampleIndicators" class="carousel slide" data-ride="carousel">
            <ol class="carousel-indicators">
              <li data-target="#carouselExampleIndicators" data-slide-to="0" class="active"></li>
              <li data-target="#carouselExampleIndicators" data-slide-to="1"></li>
              <li data-target="#carouselExampleIndicators" data-slide-to="2"></li>
              <li data-target="#carouselExampleIndicators" data-slide-to="3"></li>
            </ol>
            <div class="carousel-inner">
              <div class="carousel-item active">
                <img class="d-block w-100" src="images/Surf-_-turf.jpg" alt="First slide">
                <div class="carousel-caption d-none d-md-block">
                    <h5>PIZZA BÒ & TÔM NƯỚNG KIỂU MỸ - SURF & TURF</h5>
                    <p>Xốt Cà Chua, Xốt Phô Mai, Phô Mai Mozzarella, Tôm, Thịt Bò Mexico, Cà Chua, Hành Tây</p>
                </div>
              </div>
              <div class="carousel-item">
                <img class="d-block w-100" src="images/Okonomiyaki.jpg" alt="Second slide">
                <div class="carousel-caption d-none d-md-block">
                    <h5>PIZZA BÁNH XÈO NHẬT - OKONOMIYAKI</h5>
                    <p>Xốt Mayonnaise, Xốt Teriyaki, Phô Mai Mozzarella, Bạch Tuộc, Tôm, Bắp Cải, Bột Rong Biển, Vẩy Cá Ngừ Bào</p>
                </div>
              </div>
              <div class="carousel-item">
                <img class="d-block w-100" src="images/Ocean-mania.jpg" alt="Third slide">
                <div class="carousel-caption d-none d-md-block">
                    <h5>PIZZA HẢI SẢN XỐT MAYONNAISE - OCEAN MANIA</h5>
                    <p>Xốt Cà Chua, Phô Mai Mozzarella, Tôm, Mực, Thanh Cua, Hành Tây</p>
                </div>
              </div>
              <div class="carousel-item">
                <img class="d-block w-100" src="images/Pizzaminsea.jpg" alt="Third slide">
                <div class="carousel-caption d-none d-md-block">
                    <h5>PIZZA HẢI SẢN NHIỆT ĐỚI XỐT TIÊU - PIZZAMIN SEA</h5>
                    <p>Xốt tiêu đen, Phô Mai Mozzarella, Phô Mai Cheddar, Thơm, Hành Tây, Tôm, Mực</p>
                </div>
              </div>
            </div>
            <a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
              <span class="carousel-control-prev-icon" aria-hidden="true"></span>
              <span class="sr-only">Previous</span>
            </a>
            <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
              <span class="carousel-control-next-icon" aria-hidden="true"></span>
              <span class="sr-only">Next</span>
            </a>
          </div>
    </div>
    <!--Tại sao lại pizza 365-->
    <div class="container" style="padding: 120px 0 50px 0;">
        <div class="text-warning text-center">
            <h4>Tại sao lại là Pizza 365</h4>
            <hr style="width:50%;height:2px;border-width:0;color:orange;background-color:orange">
        </div>
        <div class="card-group">
            <div class="card border border-warning" style="background-color:lightgoldenrodyellow">
              <div class="card-body">
                <h5 class="card-title">Đa dạng</h5>
                <p class="card-text">Số lượng pizza đa dạng, có đầy đủ các loại pizza đang hot nhất hiện nay.</p>
              </div>
            </div>
            <div class="card border border-warning" style="background-color:yellow">
              <div class="card-body">
                <h5 class="card-title">Chất lượng</h5>
                <p class="card-text">Nguyên liệu sạch 100%, đảm bảo nguồn gốc, quy trình chế biến an toàn vệ sinh thực phẩm.</p>
              </div>
            </div>
            <div class="card border border-warning" style="background-color:lightsalmon">
              <div class="card-body">
                <h5 class="card-title">Hương vị</h5>
                <p class="card-text">Đảm bảo hương vị ngon, độc, lạ mà bạn chỉ có thể trải nghiệm tại pizza 365</p>
              </div>
            </div>
            <div class="card border border-warning" style="background-color:orange">
                <div class="card-body">
                  <h5 class="card-title">Dịch vụ</h5>
                  <p class="card-text">Nhân viên thân thiện, nhà hàng hiện đại, dịch vụ giao hàng nhanh, chất lượng, tân tiến</p>
                </div>
              </div>
          </div>
    </div>
    <!--menu combo-->
    <div class="container" style="padding: 120px 0 50px 0;">
        <div class="text-warning text-center">
            <h4>Chọn size pizza</h4>
            <hr style="width:50%;height:2px;border-width:0;color:orange;background-color:orange">
            <p>Chọn combo phù hợp với nhu cầu của bạn</p>
        </div>
        <div class="card-deck">
            <div class="card text-center">
              <div class="card-header bg-warning h4">S (small)</div>
              <div class="card-body">
                <p class="card-text">Đường kính <strong> 20cm</strong></p>
                <hr>
                <p class="card-text">Sườn nướng <strong> 2</strong></p>
                <hr>
                <p class="card-text">Salad<strong> 200g</strong></p>
                <hr>
                <p class="card-text">Nước ngọt <strong> 2</strong></p>
                <hr>
                <p class="h4">150.000</p>
                <p>VNĐ</p>
              </div>
              <div class="card-footer">
                <button class="btn btn-warning btn-block" id="btn-chon-small">Chọn</button>
              </div>
            </div>
            <div class="card text-center">
                <div class="card-header bg-warning h4">M (medium)</div>
                <div class="card-body">
                  <p class="card-text">Đường kính <strong> 25cm</strong></p>
                  <hr>
                  <p class="card-text">Sườn nướng <strong> 4</strong></p>
                  <hr>
                  <p class="card-text">Salad<strong> 300g</strong></p>
                  <hr>
                  <p class="card-text">Nước ngọt <strong> 3</strong></p>
                  <hr>
                  <p class="h4">200.000</p>
                  <p>VNĐ</p>
                </div>
                <div class="card-footer">
                  <button class="btn btn-warning btn-block" id="btn-chon-medium">Chọn</button>
                </div>
            </div>
            <div class="card text-center">
                <div class="card-header bg-warning h4">L (large)</div>
                <div class="card-body">
                  <p class="card-text">Đường kính <strong> 30cm</strong></p>
                  <hr>
                  <p class="card-text">Sườn nướng <strong> 8</strong></p>
                  <hr>
                  <p class="card-text">Salad<strong> 500g</strong></p>
                  <hr>
                  <p class="card-text">Nước ngọt <strong> 4</strong></p>
                  <hr>
                  <p class="h4">250.000</p>
                  <p>VNĐ</p>
                </div>
                <div class="card-footer">
                  <button class="btn btn-warning btn-block" id="btn-chon-large">Chọn</button>
                </div>
              </div>
        </div>
    </div>
    <!--Chọn loại pizza-->
    <div class="container" style="padding: 120px 0 50px 0;">
        <div class="text-warning text-center">
            <h4>Chọn loại pizza</h4>
            <hr style="width:50%;height:2px;border-width:0;color:orange;background-color:orange">
        </div>
        <div class="card-deck">
            <div class="card">
              <img class="card-img-top" src="images/Ocean-mania.jpg" alt="Ocean Mania">
              <div class="card-body">
                <h5 class="card-title" id="type-haisan">OCEAN MANIA</h5>
                <p class="card-text">Pizza Hải Sản Xốt Mayonnaise - Ocean Mania</p>
                <p class="card-text">Xốt Cà Chua, Phô Mai Mozzarella, Tôm, Mực, Thanh Cua, Hành Tây</p>
              </div>
              <div class="card-footer">
                <button class="btn btn-warning btn-block" id="btn-chon-haisan" >Chọn</button>
              </div>
            </div>
            <div class="card">
                <img class="card-img-top" src="images/Hawaiian.jpg" alt="Ocean Mania">
                <div class="card-body">
                  <h5 class="card-title" id="type-hawaii">HAWAII</h5>
                  <p class="card-text">Pizza Dăm Bông Dứa Kiểu Hawaii - Hawaiian</p>
                  <p class="card-text">Xốt Cà Chua, Phô Mai Mozzarella, Thịt Dăm Bông, Thơm</p>
                </div>
                <div class="card-footer">
                  <button class="btn btn-warning btn-block" id="btn-chon-hawaii" >Chọn</button>
                </div>
              </div>
              <div class="card">
                <img class="card-img-top" src="images/Cheesy-chicken-bacon.jpg" alt="Ocean Mania">
                <div class="card-body">
                  <h5 class="card-title" id="type-bacon">CHEESE CHICKEN BACON</h5>
                  <p class="card-text">Pizza Gà Phô Mai Thịt Heo Xông Khói - Cheesy Chicken Bacon</p>
                  <p class="card-text">Xốt Phô Mai, Thịt Gà, Thịt Heo Muối, Phô Mai Mozzarella, Cà Chua</p>
                </div>
                <div class="card-footer">
                  <button class="btn btn-warning btn-block" id="btn-chon-bacon" >Chọn</button>
                </div>
              </div>
        </div>
    </div>
    <!--Chọn loại dồ uống-->
    <div class="container" style="padding: 120px 0 50px 0;">
        <div class="text-warning text-center">
            <h4>Chọn đồ uống</h4>
            <hr style="width:50%;height:2px;border-width:0;color:orange;background-color:orange">
        </div>
        <select class="form-control" id="select-drink">
            <option value = 0>Tất cả các loại đồ uống</option>
        </select>
    </div>
    <!-- gửi đơn hàng -->
    <div class="container" style="padding: 120px 0 50px 0;">
        <div class="text-warning text-center">
          <h4>Gửi đơn hàng</h4>
          <hr style="width:50%;height:2px;border-width:0;color:orange;background-color:orange">
        </div>
        <div class="col-sm-12 p-2 jumbotron">
          <div class="row">
            <div class="col-sm-12">
              <div class="form-group">
                <label for="fullname">Họ và tên</label>
                <input type="text" class="form-control" id="inp-fullname" placeholder="Họ và tên">
              </div>
              <div class="form-group">
                  <label for="dia-chi">Địa chỉ</label>
                  <input type="text" class="form-control" id="inp-dia-chi" placeholder="Địa chỉ">
              </div>
              <div class="form-group">
                  <label for="dien-thoai">Điện thoại</label>
                  <input type="text" class="form-control" id="inp-dien-thoai" placeholder="Điện thoại">
              </div>
              <div class="form-group">
                <label for="email">Email</label>
                <input type="text" class="form-control" id="inp-email" placeholder="Email">
              </div>
              <div class="form-group">
                <label for="message">Lời nhắn</label>
                <input type="text" class="form-control" id="inp-message" placeholder="Lời nhắn">
              </div>
              <div class="form-group">
                <label for="message">Mã giảm giá (voucherID)</label>
                <input type="text" class="form-control" id="inp-ma-giam-gia" placeholder="Mã giảm giá">
              </div>
              <button type="submit" class="btn btn-warning w-100" id="btn-gui-don-hang">Gửi</button>
            </div>
          </div>
        </div>
    </div>
    <!-- footer -->
    <div class="container text-center pt-4 py-4" style="background-color:orange">
        <h6><strong>Footer</strong></h6>
        <button type="button" class="btn btn-dark"><i class="fa fa-arrow-up" aria-hidden="true"></i> To the top</button>
        <div class="row">
            <div class="col-sm-4"></div>
            <div class="col-sm-4 p-2">
                <i class="fa fa-facebook-square " aria-hidden="true"></i>
                <i class="fa fa-instagram " aria-hidden="true"></i>
                <i class="fa fa-twitter" aria-hidden="true"></i>
                <i class="fa fa-snapchat" aria-hidden="true"></i>
                <i class="fa fa-pinterest" aria-hidden="true"></i>
                <i class="fa fa-linkedin" aria-hidden="true"></i>
            </div >
            <div class="col-sm-4"></div>
        </div>
        <p>Powered by Devcamp</p>
    </div>
    <!-- modal order detail-->
    <div class="modal fade" id="modal-order-detail" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="order-detail">Thông tin đơn hàng</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <div class="form-group">
              <div>
                  <p>Họ và tên</p>
              </div>
              <div>
                  <input type="text" id="inp-modal-name" placeholder="..." >
              </div>
            </div>
            <div class="form-group">
              <div>
                  <p>Email</p>
              </div>
              <div>
                  <input type="text" id="inp-modal-email" placeholder="...">
              </div>
            </div>
            <div class="form-group">
              <div>
                  <p>Số điện thoại</p>
              </div>
              <div>
                  <input type="text" id="inp-modal-phone-number" placeholder="...">
              </div>
            </div>
            <div class="form-group">
              <div>
                  <p>Địa chỉ</p>
              </div>
              <div>
                  <input type="text" id="inp-modal-address" placeholder="...">
              </div>
            </div>
            <div class="form-group">
              <div>
                  <p>Lời nhắn</p>
              </div>
              <div>
                  <input type="text" id="inp-modal-message" placeholder="...">
              </div>
            </div>
            <div class="form-group">
              <div>
                  <p>Mã giảm giá</p>
              </div>
              <div>
                  <input type="text" id="inp-modal-voucher-id" placeholder="...">
              </div>
            </div>
            <div class="form-group">
              <div>
                  <p>Thông tin chi tiết</p>
              </div>
              <div>
                  <textarea rows="10" type="text" id="text-modal-order-detail" placeholder="..." style="overflow: hidden"></textarea>
              </div>
            </div>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-danger" data-dismiss="modal">Quay lại</button>
            <button type="button" class="btn btn-warning" id="btn-create-order">Tạo đơn</button>
          </div>
        </div>
      </div>
    </div>
    <!-- modal order detail-->
    <div class="container">
      <div class="jumnotron">
        <div class="modal" tabindex="-1" role="dialog" id="modal-result">
          <div class="modal-dialog modal-lg" role="document">
            <div class="modal-content bg bg-warning">
              <div class="modal-header" style="border-bottom: 0 none">
                <h5 class="modal-title">Cám ơn bạn đã đặt hàng tại pizza 365. Mã đơn hàng của bạn là:</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="row form-group text-center">
                <div class="col-sm-3 ">
                    <label><strong>Mã đơn hàng:</strong></label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="inp-order-id" style="width:70%">
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </body>
<script>
  "use strict";
  $(document).ready(function(){
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  //biến toàn cục lưu giá trị size pizza được chọn, mỗi lần khách chọn lại đổi giá trị
  var gSelectedMenuStructure = {
      menuName: "",    // S, M, L
      duongKinhCM: 0,
      suongNuong: 0,
      saladGr: 0,
      drink: 0,
      priceVND: 0
    }
  // biến toàn cục dùng để lưu loại pizza đươc chọn, mỗi khi khách chọn, bạn lại đổi giá trị cho nó
  var gSelectedPizzaType = ""
  //biến toàn cục lưu %giảm giá
  var gPercentageDiscount;
  //biến thông tin khách hàng chọn
  var gCustomerDataObj = {
        menuDuocChon:"",     
        loaiPizza:"",
        loaiNuocUong:"",
        hoVaTen: "",
        email: "",
        dienThoai: "",
        diaChi: "",
        loiNhan: "",
        voucher: "",
        priceAnnualVND:0
      }
  //link server load all drinks
  const gDRINK_URL ="http://42.115.221.44:8080/devcamp-pizza365/drinks";
  //link server get voucher by voucher id
  const gVOUCHER_URL = "http://42.115.221.44:8080/devcamp-voucher-api/voucher_detail/";
  //link server get orders
  const gORDER_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  //load drink list khi tải trang
   getOptionsDrinkToSelect();
  //khi chọn combo size S
  $("#btn-chon-small").on('click',function(){
    onBtnChonSmallClick(this)
  });
  //khi chọn combo size M
  $("#btn-chon-medium").on('click',function(){
    onBtnChonMediumClick(this)
  });
  //khi chọn combo size L
  $("#btn-chon-large").on('click',function(){
    onBtnChonLargeClick(this)
  });
  //khi chọn loại hawaii
  $('#btn-chon-hawaii').on('click',function(){
    onBtnChonHawaiiClick(this);
  });
  //khi chọn loại hải sản
  $('#btn-chon-haisan').on('click',function(){
    onBtnChonHaiSanClick(this);
  });
  //khi chọn loại hải sản
  $('#btn-chon-bacon').on('click',function(){
    onBtnChonBaconClick(this);
  });
  //ấn nút gửi đơn hàng
  $('#btn-gui-don-hang').on('click',function(){
    onBtnGuiClick();
  });
  //ấn nút tạo đơn hàng
  $('#btn-create-order').on('click',function(){
    onBtnCreateOrderClick()
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  //hàm xử lý sự kiện click chọn combo size s
  function  onBtnChonSmallClick(parambtn){
    //đổi màu nút được chọn
      changeBtnMenuColor("small");
    //1.Đọc giá trị 
      var vSelectedMenu = getMenuInfo("S(small)","20cm",2,"200g",2, 150000);
    //2. validate không có
    //3. Hiển thị và ghi vào biến toàn cục
      vSelectedMenu.displayInConsoleLog();
      gSelectedMenuStructure = vSelectedMenu;
  }
  //hàm xử lý sự kiện click chọn combo size m
  function onBtnChonMediumClick(parambtn){
    //đổi màu nút được chọn
      changeBtnMenuColor("medium");
    //1.Đọc giá trị 
      var vSelectedMenu= getMenuInfo("M(medium)","25cm",4,"300g",3,200000);
    //2. validate không có
    //3. Hiển thị và ghi vào biến toàn cục
      vSelectedMenu.displayInConsoleLog();
      gSelectedMenuStructure = vSelectedMenu;
  }
  //hàm xử lý sự kiện click chọn combo size l
  function onBtnChonLargeClick(parambtn){
    //đổi màu nút được chọn
      changeBtnMenuColor("large");
    //1.Đọc giá trị 
      var vSelectedMenu = getMenuInfo("L(large)","30cm",8,"500g",4,250000);
    //2. validate không có
    //3. Hiển thị và ghi vào biến toàn cục  
      vSelectedMenu.displayInConsoleLog();
      gSelectedMenuStructure = vSelectedMenu;
  }
  //hàm ghi thông tin loại pizza được chọn
    function onBtnChonHawaiiClick(parambtn){
        //đổi màu nút được chọn
        changeBtnTypeColor("hawaii");
        //1.Đọc giá trị 
        var vSelectedType = $("#type-hawaii");
        //2. validate không có
        //3. Hiển thị và ghi vào biến toàn cục  
        gSelectedPizzaType = vSelectedType.html();
        console.log("Loại pizza được chọn là:");
        console.log(gSelectedPizzaType);
    }
    function onBtnChonHaiSanClick(parambtn){
        //đổi màu nút được chọn
        changeBtnTypeColor("haisan");
        //1.Đọc giá trị
        var vSelectedType = $("#type-haisan");
        //2. validate không có
        //3. Hiển thị và ghi vào biến toàn cục
        gSelectedPizzaType = vSelectedType.html();
        console.log("Loại pizza được chọn là:");
        console.log(gSelectedPizzaType);
    }
    function onBtnChonBaconClick(parambtn){
        //đổi màu nút được chọn
        changeBtnTypeColor("bacon");
        //1.Đọc giá trị
        var vSelectedType = $("#type-bacon");
        //2. validate không có
        //3. Hiển thị và ghi vào biến toàn cục
        gSelectedPizzaType = vSelectedType.html();
        console.log("Loại pizza được chọn là:");
        console.log(gSelectedPizzaType);
    }
    //hàm đọc và kiểm tra thông tin khi ấn nút Kiểm tra đơn hàng
    function onBtnGuiClick(){
      
      //1.Đọc thông tin
      getCustomerData(gCustomerDataObj);
      console.log(gCustomerDataObj);
      //2.validate
      if (validateCustomerData(gCustomerDataObj) ==true && isEmailValid(gCustomerDataObj)==true){
        console.log(gCustomerDataObj);
        //3. Hiển thị đơn hàng lên modal
        displayOrderDetailModal(gCustomerDataObj);
        $('#modal-order-detail').modal('show');
      }
    }
    //hàm xử lý nút tạo đơn hàng
    function onBtnCreateOrderClick( ){
      //1. đọc thông tin
      var vObjectRequest = {
            kichCo: gSelectedMenuStructure.menuName,
            duongKinh: gSelectedMenuStructure.duongKinhCM,
            suon: gSelectedMenuStructure.duongKinhCM.suongNuong,
            salad: gSelectedMenuStructure.saladGr,
            loaiPizza: gSelectedPizzaType,
            idVourcher: gCustomerDataObj.voucher,
            idLoaiNuocUong:  $("#select-drink option:selected").val(),
            soLuongNuoc: gSelectedMenuStructure.drink,
            hoTen: gCustomerDataObj.hoVaTen,
            thanhTien: gCustomerDataObj.priceAnnualVND,
            email: gCustomerDataObj.email,
            soDienThoai: gCustomerDataObj.dienThoai,
            diaChi: gCustomerDataObj.diaChi,
            loiNhan: gCustomerDataObj.loiNhan
        }
        //2.validate không có
        //3. gọi API tạo đơn hàng trên server
        callAPICreateOrder(vObjectRequest);
    }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // hàm đổi màu nút chọn menu
function changeBtnMenuColor(paramBtn){
    var vBtnSmall = $("#btn-chon-small");
    var vBtnMedium = $("#btn-chon-medium");
    var vBtnLarge = $("#btn-chon-large");

    if (paramBtn == "small"){
        vBtnSmall.css('background-color','lightgreen') ;
        vBtnMedium.css('background-color','orange') ;
        vBtnLarge.css('background-color','orange') ;
    } else if (paramBtn == "medium"){
        vBtnSmall.css('background-color','orange') ;
        vBtnMedium.css('background-color','lightgreen') ;
        vBtnLarge.css('background-color','orange') ;
    } else if (paramBtn == "large"){
        vBtnSmall.css('background-color','orange') ;
        vBtnMedium.css('background-color','orange') ;
        vBtnLarge.css('background-color','lightgreen') ;
    }
}
//hàm lấy thông tin khách chọn
function getMenuInfo (paramMenuName,paramDuongKinh,paramSuonNuong,paramSalad,paramDrink,paramPrice) {
    var vSelectedMenu = {
        menuName: paramMenuName,
        duongKinhCM: paramDuongKinh,
        suongNuong: paramSuonNuong,
        saladGr: paramSalad,
        drink: paramDrink,
        priceVND: paramPrice,

        displayInConsoleLog() {
      console.log("%cMenu được chọn ", "color:blue");
      console.log(this.menuName);  
      console.log("Đường kính: " + this.duongKinhCM);
      console.log("Sườn nướng: " + this.suongNuong); 
      console.log("Salad: " + this.saladGr);
      console.log("Nước ngọt:" + this.drink);
      console.log("Price per piece: " + "VND" + this.priceVND);
        }   
    }
    return vSelectedMenu;
}
//hàm dổi màu nút chọn loại bánh
function changeBtnTypeColor(paramBtn){
    var vBtnHawaii = $("#btn-chon-hawaii");
    var vBtnHaiSan = $("#btn-chon-haisan");
    var vBtnBacon = $("#btn-chon-bacon");

    if (paramBtn == "hawaii"){
        vBtnHawaii.css('background-color','lightgreen') ;
        vBtnHaiSan.css('background-color','orange') ;
        vBtnBacon.css('background-color','orange') ;
    } else if (paramBtn == "haisan"){
        vBtnHawaii.css('background-color','orange') ;
        vBtnHaiSan.css('background-color','lightgreen') ;
        vBtnBacon.css('background-color','orange') ;
    } else if (paramBtn == "bacon"){
        vBtnHawaii.css('background-color','orange') ;
        vBtnHaiSan.css('background-color','orange') ;
        vBtnBacon.css('background-color','lightgreen') ;
    }
}
//hàm gọi server lấy list drink
function getOptionsDrinkToSelect(){
    var vOptionsDrinkObject;
    $.ajax({
      url: gDRINK_URL,
      type:'GET',
      dataType:'json',
      success: function(response){
        console.log(response)
        vOptionsDrinkObject = response;
        //call back funtion
        loadDrinkListToSelect(vOptionsDrinkObject)
      },
      error: function(res){
        console.assert(res.responseText)
      }

    })
}
//load drink list to select
function loadDrinkListToSelect(paramDrinkObject) {  
    for (var bIndex = 0; bIndex < paramDrinkObject.length;bIndex++){
        var vSelectElement = $("#select-drink");
        var vOptionElement = $("<option></option>").val(paramDrinkObject[bIndex].maNuocUong);
        vOptionElement = $("<option></option>").text(paramDrinkObject[bIndex].tenNuocUong)
        vOptionElement.appendTo(vSelectElement);
    }
}
//hàm đọc dữ liệu khách hàng trên form 
function getCustomerData(paramCustomerInfoObj){
    var vSelectedDrinkOption = $("#select-drink option:selected");
    var vInpHoTen = $("#inp-fullname");
    var vInpEmail = $("#inp-email");
    var vInpDiaChi = $("#inp-dia-chi");
    var vInpDienThoai = $("#inp-dien-thoai");
    var vInpLoiNhan = $("#inp-message");
    var vInpVoucher = $("#inp-ma-giam-gia");
    var vInpVoucherValue = vInpVoucher.val();

    paramCustomerInfoObj.menuDuocChon = gSelectedMenuStructure.menuName;
    paramCustomerInfoObj.loaiPizza = gSelectedPizzaType;  
    paramCustomerInfoObj.loaiNuocUong = vSelectedDrinkOption.text() ; 
    paramCustomerInfoObj.hoVaTen = vInpHoTen.val();    
    paramCustomerInfoObj.email = vInpEmail.val();    
    paramCustomerInfoObj.diaChi = vInpDiaChi.val();   
    paramCustomerInfoObj.dienThoai = vInpDienThoai.val();  
    paramCustomerInfoObj.loiNhan = vInpLoiNhan.val();
    paramCustomerInfoObj.voucher = vInpVoucherValue;
    paramCustomerInfoObj.priceAnnualVND = getPriceAfterDiscount(vInpVoucherValue);  
}
//hàm tìm phần trăm discount khi biết mã giảm giá
function getPercentageDiscount(paramVoucher){
    if(paramVoucher!="") {
      $.ajax({
          url: gVOUCHER_URL + paramVoucher,
          async: false,
          dataType: 'json',
          type: 'GET',
          success: function (response){
            console.log(response)
            gPercentageDiscount= response.phanTramGiamGia;
          },
          error: function (res){
            alert("Mã giảm giá không tồn tại");
            console.assert("Không tìm thấy voucher " + vXmlHttp.responseText);
          }
      })
        return gPercentageDiscount; 
    }
    return gPercentageDiscount;
}
//hàm tính giá sau khi discount
function getPriceAfterDiscount(paramVoucherInp){
        var vDiscountPercentage = Number(getPercentageDiscount(paramVoucherInp));
        var vPriceVND = gSelectedMenuStructure.priceVND;
        var vPriceAfterDiscount=0
        if (vDiscountPercentage == 0){                              
            return vPriceVND;
        } else {vPriceAfterDiscount = vPriceVND * (1-(vDiscountPercentage)/100); 
            return vPriceAfterDiscount;
        }       
}  
//hàm kiểm tra dữ liệu
function validateCustomerData(paramCustomerInfoObj){
        if(paramCustomerInfoObj.menuDuocChon ==""){
            alert("Bạn chưa chọn menu");
            return false;
        } else if (paramCustomerInfoObj.loaiPizza ==""){
            alert("Bạn chưa chọn loại pizza!");
            return false;
        } else if (paramCustomerInfoObj.loaiNuocUong == "Tất cả các loại đồ uống"){
            alert("Bạn chưa chọn đồ uống!");
            return false;
        } else if (paramCustomerInfoObj.hoVaTen ==""){
            alert ("Bạn chưa nhập họ tên!");
            return false;
        } else if (paramCustomerInfoObj.diaChi ==""){
            alert ("Bạn chưa nhập địa chỉ!");
            return false;
        } else if (paramCustomerInfoObj.dienThoai ==""){
            alert ("Bạn chưa nhập số điện thoại!");
            return false;
        }  return true;
            console.log("Dữ liệu hợp lệ")
    }
//hàm kiểm tra email
function isEmailValid (paramCustomerInfoObj){
        if (paramCustomerInfoObj.email.indexOf("@")>0 && paramCustomerInfoObj.email.indexOf("@")<paramCustomerInfoObj.email.length-1){
            return true;
            console.log("Email hợp lệ")
        } alert("Email không hợp lệ")
    }
//hàm display thông tin đơn hàng lên modal
function displayOrderDetailModal(paramCustomerDataObj){
    $('#inp-modal-name').val(paramCustomerDataObj.hoVaTen)
    $('#inp-modal-email').val(paramCustomerDataObj.email)
    $('#inp-modal-phone-number').val(paramCustomerDataObj.dienThoai)
    $('#inp-modal-address').val(paramCustomerDataObj.diaChi)
    $('#inp-modal-message').val(paramCustomerDataObj.loiNhan)
    $('#inp-modal-voucher-id').val(paramCustomerDataObj.voucher)
    $('#text-modal-order-detail').val(
      "Xác nhận: " + paramCustomerDataObj.hoVaTen + '\n' +
      "Điện thoại: " + paramCustomerDataObj.dienThoai  +'\n' + 
      "Địa chỉ: " + paramCustomerDataObj.diaChi + '\n' + 
      "Menu " + gSelectedMenuStructure.menuName + "sườn " + gSelectedMenuStructure.suongNuong + " " + "nước " + gSelectedMenuStructure.drink +'\n' +
      "Loại pizza " + gSelectedPizzaType + '\n' +
      "Giá " + gSelectedMenuStructure.priceVND + '\n' + 
      "Mã giảm giá " + paramCustomerDataObj.voucher + '\n' +
      "Phải thanh toán " + paramCustomerDataObj.priceAnnualVND + "(giảm giá " + gPercentageDiscount + '%)'
    )

}
//hàm gọi api tạo đơn hàng
function callAPICreateOrder(paramOrderObject){
  $.ajax({
    url: gORDER_URL,
    type:'POST',
    data: JSON.stringify(paramOrderObject),
    contentType: "application/json;charset=UTF-8",
    async: false,
    success: function(res){
      //call back function
      console.log(res)
      displayOrderIdToModal(res)
    },
    error: function (res){
      console.assert(res.responseText)
    }
  })
}
//hàm ghi orderid lên modal result
function displayOrderIdToModal(paramResponse){
    $('#inp-order-id').val(paramResponse.orderId);
    $('#modal-order-detail').modal('hide');
    $('#modal-result').modal('show');
}
    

})
</script>
</html>